### VFX function to trigger VFX based on settings
### triggered by: loop20
### high is assumed to be base VFX setting


tag @a remove particle_spawner_8
execute as @a at @s unless entity @a[tag=particle_spawner_8,r=8] run tag @s add particle_spawner_8

tag @a remove particle_spawner_15
execute as @a at @s unless entity @a[tag=particle_spawner_15,r=15] run tag @s add particle_spawner_15

tag @a remove particle_spawner_40
execute as @a at @s unless entity @a[tag=particle_spawner_40,r=40] run tag @s add particle_spawner_40

tag @a remove particle_spawner_60
execute as @a at @s unless entity @a[tag=particle_spawner_60,r=60] run tag @s add particle_spawner_60

tag @a remove particle_spawner_180
execute as @a at @s unless entity @a[tag=particle_spawner_180,r=180] run tag @s add particle_spawner_180

# Night time fog
execute if score daytime SS_worldtime matches 13000..23000 run fog @a[scores={SS_dimension=0}] push spark:no_fog none
execute unless score daytime SS_worldtime matches 13000..23000 run fog @a remove none
fog @a[scores={SS_dimension=!0}] remove none


# Adding some effects here for now, to be distributed into graphics levels later
# Events

# Shooting Star
execute if score daytime SS_worldtime matches 13000..13020 run scoreboard players random shooting_star_chance SS_worldtime 1 4
execute if score daytime SS_worldtime matches 13000..13020 run scoreboard players operation shooting_star_chance SS_worldtime *= shooting_star_chance SS_worldtime
execute unless score shooting_stars SS_realism_settings matches 0 run scoreboard players random e1 SS_temp 0 180
execute unless score shooting_stars SS_realism_settings matches 0 run scoreboard players operation e1 SS_temp /= shooting_star_chance SS_worldtime
execute unless score shooting_stars SS_realism_settings matches 0 if score daytime SS_worldtime matches 13400..22600 if score e1 SS_temp matches 1 at @r[scores={SS_dimension=0}] run function spark/vfx/events/shooting_star
# Meteor shower
execute unless score meteor_showers SS_realism_settings matches 0 if score daytime SS_worldtime matches 13400..21000 run scoreboard players random e2 SS_temp 0 600
execute unless score meteor_showers SS_realism_settings matches 0 if score daytime SS_worldtime matches 13400..21000 if score e2 SS_temp matches 1 unless score meteor_shower SS_worldtime matches 1.. run scoreboard players random meteor_shower SS_worldtime 30 60
execute unless score meteor_showers SS_realism_settings matches 0 if score meteor_shower SS_worldtime matches 1.. run function spark/vfx/events/meteor_shower


# Northern Lights
# Set to 0.400 to trigger statistically once a night
execute unless score northern_lights SS_realism_settings matches 0 if score daytime SS_worldtime matches 13400..18000 run scoreboard players random e3 SS_temp 0 600
execute unless score northern_lights SS_realism_settings matches 0 if score daytime SS_worldtime matches 13400..18000 if score e3 SS_temp matches 1 unless score northern_lights SS_worldtime matches 1.. as @r[scores={SS_dimension=0,SS_biome=8,SS_y_pos=61..100}] run scoreboard players set northern_lights SS_worldtime 128
execute unless score northern_lights SS_realism_settings matches 0 if score northern_lights SS_worldtime matches 108 as @r[scores={SS_dimension=0,SS_biome=8,SS_y_pos=61..100}] at @s run function spark/vfx/events/northern_lights
execute if score northern_lights SS_worldtime matches 1.. run scoreboard players remove northern_lights SS_worldtime 1

# Dust
execute unless score desert_sand SS_realism_settings matches 0 at @a[tag=particle_spawner_8,scores={SS_biome=2,SS_y_pos=62..80}] run particle spark:sand_air ~ ~ ~
execute unless score cave_dust SS_realism_settings matches 0 at @a[tag=particle_spawner_8,scores={SS_y_pos=..50}] if block ~ ~-1.5 ~ minecraft:stone [] run particle spark:cave_dust ~ ~ ~
execute unless score cave_dust SS_realism_settings matches 0 at @a[tag=particle_spawner_8,scores={SS_y_pos=..50}] if block ~ ~-1.5 ~ minecraft:deepslate [] run particle spark:cave_dust ~ ~ ~
execute unless score water_bubbles SS_realism_settings matches 0 at @a[tag=particle_spawner_8,scores={SS_dimension=0}] if block ~ ~.5 ~ water [] run particle spark:underwater_dust ~ ~ ~
execute unless score water_bubbles SS_realism_settings matches 0 at @a[tag=particle_spawner_8,scores={SS_dimension=0}] if block ~ ~.5 ~ water [] run particle spark:underwater_bubbles ~ ~ ~

# Birds
scoreboard players random @a SS_temp 0 40
execute unless score birds SS_realism_settings matches 0 as @a[scores={SS_dimension=0,SS_y_pos=63..200,SS_temp=1},tag=particle_spawner_60] at @s run particle spark:sky_goose ~ ~ ~
execute unless score birds SS_realism_settings matches 0 as @a[scores={SS_dimension=0,SS_y_pos=63..200,SS_temp=2},tag=particle_spawner_60] at @s run particle spark:sky_buzzard ~ ~ ~
execute unless score birds SS_realism_settings matches 0 as @a[scores={SS_dimension=0,SS_y_pos=63..200,SS_temp=3..4},tag=particle_spawner_60] at @s run particle spark:sky_crow ~ ~ ~

# Wind
execute unless score visible_wind SS_realism_settings matches 0 at @a[scores={SS_biome=9..10,SS_y_pos=75..},tag=particle_spawner_15] run particle spark:visible_wind ~ ~ ~