# © Spark Universe, 2023
# description: Game loop, runs 20 times a second
# called by: tick.json


# Slow loop
scoreboard players add slow SS_time 1
execute as @a[c=1] if score slow SS_time matches 20.. run function spark/loop20
# Timing offset to distribute performance impact
execute as @a[c=1] if score slow SS_time matches 10 run function spark/vfx/trigger

scoreboard players add hz10 SS_time 1
execute if score hz10 SS_time matches 2 run function spark/vfx/loop_fast

# sound system
function spark/sound_system/loop